diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-embed.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-embed.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-embed.php	1969-12-31 17:00:00.000000000 -0700
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-embed.php	2012-12-17 16:18:39.000000000 -0600
***************
*** 0 ****
--- 1,277 ----
+ <?php
+ /**
+  * API for easily embedding rich media such as videos and images into content.
+  *
+  * @package WordPress
+  * @subpackage Embed
+  * @since 2.9.0
+  */
+ class WP_Embed {
+ 	var $handlers = array();
+ 	var $post_ID;
+ 	var $usecache = true;
+ 	var $linkifunknown = true;
+ 
+ 	/**
+ 	 * Constructor
+ 	 */
+ 	function __construct() {
+ 		// Hack to get the [embed] shortcode to run before wpautop()
+ 		add_filter( 'the_content', array( $this, 'run_shortcode' ), 8 );
+ 
+ 		// Shortcode placeholder for strip_shortcodes()
+ 		add_shortcode( 'embed', '__return_false' );
+ 
+ 		// Attempts to embed all URLs in a post
+ 		add_filter( 'the_content', array( $this, 'autoembed' ), 8 );
+ 
+ 		// When a post is saved, invalidate the oEmbed cache
+ 		add_action( 'pre_post_update', array( $this, 'delete_oembed_caches' ) );
+ 
+ 		// After a post is saved, cache oEmbed items via AJAX
+ 		add_action( 'edit_form_advanced', array( $this, 'maybe_run_ajax_cache' ) );
+ 	}
+ 
+ 	/**
+ 	 * Process the [embed] shortcode.
+ 	 *
+ 	 * Since the [embed] shortcode needs to be run earlier than other shortcodes,
+ 	 * this function removes all existing shortcodes, registers the [embed] shortcode,
+ 	 * calls {@link do_shortcode()}, and then re-registers the old shortcodes.
+ 	 *
+ 	 * @uses $shortcode_tags
+ 	 * @uses remove_all_shortcodes()
+ 	 * @uses add_shortcode()
+ 	 * @uses do_shortcode()
+ 	 *
+ 	 * @param string $content Content to parse
+ 	 * @return string Content with shortcode parsed
+ 	 */
+ 	function run_shortcode( $content ) {
+ 		global $shortcode_tags;
+ 
+ 		// Back up current registered shortcodes and clear them all out
+ 		$orig_shortcode_tags = $shortcode_tags;
+ 		remove_all_shortcodes();
+ 
+ 		add_shortcode( 'embed', array( $this, 'shortcode' ) );
+ 
+ 		// Do the shortcode (only the [embed] one is registered)
+ 		$content = do_shortcode( $content );
+ 
+ 		// Put the original shortcodes back
+ 		$shortcode_tags = $orig_shortcode_tags;
+ 
+ 		return $content;
+ 	}
+ 
+ 	/**
+ 	 * If a post/page was saved, then output JavaScript to make
+ 	 * an AJAX request that will call WP_Embed::cache_oembed().
+ 	 */
+ 	function maybe_run_ajax_cache() {
+ 		$post = get_post();
+ 
+ 		if ( ! $post || empty($_GET['message']) || 1 != $_GET['message'] )
+ 			return;
+ 
+ ?>
+ <script type="text/javascript">
+ /* <![CDATA[ */
+ 	jQuery(document).ready(function($){
+ 		$.get("<?php echo admin_url( 'admin-ajax.php?action=oembed-cache&post=' . $post->ID, 'relative' ); ?>");
+ 	});
+ /* ]]> */
+ </script>
+ <?php
+ 	}
+ 
+ 	/**
+ 	 * Register an embed handler. Do not use this function directly, use {@link wp_embed_register_handler()} instead.
+ 	 * This function should probably also only be used for sites that do not support oEmbed.
+ 	 *
+ 	 * @param string $id An internal ID/name for the handler. Needs to be unique.
+ 	 * @param string $regex The regex that will be used to see if this handler should be used for a URL.
+ 	 * @param callback $callback The callback function that will be called if the regex is matched.
+ 	 * @param int $priority Optional. Used to specify the order in which the registered handlers will be tested (default: 10). Lower numbers correspond with earlier testing, and handlers with the same priority are tested in the order in which they were added to the action.
+ 	 */
+ 	function register_handler( $id, $regex, $callback, $priority = 10 ) {
+ 		$this->handlers[$priority][$id] = array(
+ 			'regex'    => $regex,
+ 			'callback' => $callback,
+ 		);
+ 	}
+ 
+ 	/**
+ 	 * Unregister a previously registered embed handler. Do not use this function directly, use {@link wp_embed_unregister_handler()} instead.
+ 	 *
+ 	 * @param string $id The handler ID that should be removed.
+ 	 * @param int $priority Optional. The priority of the handler to be removed (default: 10).
+ 	 */
+ 	function unregister_handler( $id, $priority = 10 ) {
+ 		if ( isset($this->handlers[$priority][$id]) )
+ 			unset($this->handlers[$priority][$id]);
+ 	}
+ 
+ 	/**
+ 	 * The {@link do_shortcode()} callback function.
+ 	 *
+ 	 * Attempts to convert a URL into embed HTML. Starts by checking the URL against the regex of the registered embed handlers.
+ 	 * If none of the regex matches and it's enabled, then the URL will be given to the {@link WP_oEmbed} class.
+ 	 *
+ 	 * @uses wp_oembed_get()
+ 	 * @uses wp_parse_args()
+ 	 * @uses wp_embed_defaults()
+ 	 * @uses WP_Embed::maybe_make_link()
+ 	 * @uses get_option()
+ 	 * @uses author_can()
+ 	 * @uses wp_cache_get()
+ 	 * @uses wp_cache_set()
+ 	 * @uses get_post_meta()
+ 	 * @uses update_post_meta()
+ 	 *
+ 	 * @param array $attr Shortcode attributes.
+ 	 * @param string $url The URL attempting to be embedded.
+ 	 * @return string The embed HTML on success, otherwise the original URL.
+ 	 */
+ 	function shortcode( $attr, $url = '' ) {
+ 		$post = get_post();
+ 
+ 		if ( empty( $url ) )
+ 			return '';
+ 
+ 		$rawattr = $attr;
+ 		$attr = wp_parse_args( $attr, wp_embed_defaults() );
+ 
+ 		// kses converts & into &amp; and we need to undo this
+ 		// See http://core.trac.wordpress.org/ticket/11311
+ 		$url = str_replace( '&amp;', '&', $url );
+ 
+ 		// Look for known internal handlers
+ 		ksort( $this->handlers );
+ 		foreach ( $this->handlers as $priority => $handlers ) {
+ 			foreach ( $handlers as $id => $handler ) {
+ 				if ( preg_match( $handler['regex'], $url, $matches ) && is_callable( $handler['callback'] ) ) {
+ 					if ( false !== $return = call_user_func( $handler['callback'], $matches, $attr, $url, $rawattr ) )
+ 						return apply_filters( 'embed_handler_html', $return, $url, $attr );
+ 				}
+ 			}
+ 		}
+ 
+ 		$post_ID = ( ! empty( $post->ID ) ) ? $post->ID : null;
+ 		if ( ! empty( $this->post_ID ) ) // Potentially set by WP_Embed::cache_oembed()
+ 			$post_ID = $this->post_ID;
+ 
+ 		// Unknown URL format. Let oEmbed have a go.
+ 		if ( $post_ID ) {
+ 
+ 			// Check for a cached result (stored in the post meta)
+ 			$cachekey = '_oembed_' . md5( $url . serialize( $attr ) );
+ 			if ( $this->usecache ) {
+ 				$cache = get_post_meta( $post_ID, $cachekey, true );
+ 
+ 				// Failures are cached
+ 				if ( '{{unknown}}' === $cache )
+ 					return $this->maybe_make_link( $url );
+ 
+ 				if ( ! empty( $cache ) )
+ 					return apply_filters( 'embed_oembed_html', $cache, $url, $attr, $post_ID );
+ 			}
+ 
+ 			// Use oEmbed to get the HTML
+ 			$attr['discover'] = ( apply_filters('embed_oembed_discover', false) && author_can( $post_ID, 'unfiltered_html' ) );
+ 			$html = wp_oembed_get( $url, $attr );
+ 
+ 			// Cache the result
+ 			$cache = ( $html ) ? $html : '{{unknown}}';
+ 			update_post_meta( $post_ID, $cachekey, $cache );
+ 
+ 			// If there was a result, return it
+ 			if ( $html )
+ 				return apply_filters( 'embed_oembed_html', $html, $url, $attr, $post_ID );
+ 		}
+ 
+ 		// Still unknown
+ 		return $this->maybe_make_link( $url );
+ 	}
+ 
+ 	/**
+ 	 * Delete all oEmbed caches.
+ 	 *
+ 	 * @param int $post_ID Post ID to delete the caches for.
+ 	 */
+ 	function delete_oembed_caches( $post_ID ) {
+ 		$post_metas = get_post_custom_keys( $post_ID );
+ 		if ( empty($post_metas) )
+ 			return;
+ 
+ 		foreach( $post_metas as $post_meta_key ) {
+ 			if ( '_oembed_' == substr( $post_meta_key, 0, 8 ) )
+ 				delete_post_meta( $post_ID, $post_meta_key );
+ 		}
+ 	}
+ 
+ 	/**
+ 	 * Triggers a caching of all oEmbed results.
+ 	 *
+ 	 * @param int $post_ID Post ID to do the caching for.
+ 	 */
+ 	function cache_oembed( $post_ID ) {
+ 		$post = get_post( $post_ID );
+ 
+ 		if ( empty($post->ID) || !in_array( $post->post_type, apply_filters( 'embed_cache_oembed_types', array( 'post', 'page' ) ) ) )
+ 			return;
+ 
+ 		// Trigger a caching
+ 		if ( !empty($post->post_content) ) {
+ 			$this->post_ID = $post->ID;
+ 			$this->usecache = false;
+ 
+ 			$content = $this->run_shortcode( $post->post_content );
+ 			$this->autoembed( $content );
+ 
+ 			$this->usecache = true;
+ 		}
+ 	}
+ 
+ 	/**
+ 	 * Passes any unlinked URLs that are on their own line to {@link WP_Embed::shortcode()} for potential embedding.
+ 	 *
+ 	 * @uses WP_Embed::autoembed_callback()
+ 	 *
+ 	 * @param string $content The content to be searched.
+ 	 * @return string Potentially modified $content.
+ 	 */
+ 	function autoembed( $content ) {
+ 		return preg_replace_callback( '|^\s*(https?://[^\s"]+)\s*$|im', array( $this, 'autoembed_callback' ), $content );
+ 	}
+ 
+ 	/**
+ 	 * Callback function for {@link WP_Embed::autoembed()}.
+ 	 *
+ 	 * @uses WP_Embed::shortcode()
+ 	 *
+ 	 * @param array $match A regex match array.
+ 	 * @return string The embed HTML on success, otherwise the original URL.
+ 	 */
+ 	function autoembed_callback( $match ) {
+ 		$oldval = $this->linkifunknown;
+ 		$this->linkifunknown = false;
+ 		$return = $this->shortcode( array(), $match[1] );
+ 		$this->linkifunknown = $oldval;
+ 
+ 		return "\n$return\n";
+ 	}
+ 
+ 	/**
+ 	 * Conditionally makes a hyperlink based on an internal class variable.
+ 	 *
+ 	 * @param string $url URL to potentially be linked.
+ 	 * @return string Linked URL or the original URL.
+ 	 */
+ 	function maybe_make_link( $url ) {
+ 		$output = ( $this->linkifunknown ) ? '<a href="' . esc_attr($url) . '">' . esc_html($url) . '</a>' : $url;
+ 		return apply_filters( 'embed_maybe_make_link', $output, $url );
+ 	}
+ }
+ $GLOBALS['wp_embed'] = new WP_Embed();
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-image-editor-gd.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-image-editor-gd.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/class-wp-image-editor-gd.php	1969-12-31 17:00:00.000000000 -0700
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/class-wp-image-editor-gd.php	2012-12-17 16:18:40.000000000 -0600
***************
*** 0 ****
--- 1,390 ----
+ <?php
+ /**
+  * WordPress GD Image Editor
+  *
+  * @package WordPress
+  * @subpackage Image_Editor
+  */
+ 
+ /**
+  * WordPress Image Editor Class for Image Manipulation through GD
+  *
+  * @since 3.5.0
+  * @package WordPress
+  * @subpackage Image_Editor
+  * @uses WP_Image_Editor Extends class
+  */
+ class WP_Image_Editor_GD extends WP_Image_Editor {
+ 
+ 	protected $image = false; // GD Resource
+ 
+ 	function __destruct() {
+ 		if ( $this->image ) {
+ 			// we don't need the original in memory anymore
+ 			imagedestroy( $this->image );
+ 		}
+ 	}
+ 
+ 	/**
+ 	 * Checks to see if current environment supports GD.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @return boolean
+ 	 */
+ 	public static function test( $args = array() ) {
+ 		if ( ! extension_loaded('gd') || ! function_exists('gd_info') )
+ 			return false;
+ 
+ 		// On some setups GD library does not provide imagerotate() - Ticket #11536
+ 		if ( isset( $args['methods'] ) &&
+ 			 in_array( 'rotate', $args['methods'] ) &&
+ 			 ! function_exists('imagerotate') ){
+ 
+ 				return false;
+ 		}
+ 
+ 		return true;
+ 	}
+ 
+ 	/**
+ 	 * Checks to see if editor supports the mime-type specified.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param string $mime_type
+ 	 * @return boolean
+ 	 */
+ 	public static function supports_mime_type( $mime_type ) {
+ 		$image_types = imagetypes();
+ 		switch( $mime_type ) {
+ 			case 'image/jpeg':
+ 				return ($image_types & IMG_JPG) != 0;
+ 			case 'image/png':
+ 				return ($image_types & IMG_PNG) != 0;
+ 			case 'image/gif':
+ 				return ($image_types & IMG_GIF) != 0;
+ 		}
+ 
+ 		return false;
+ 	}
+ 
+ 	/**
+ 	 * Loads image from $this->file into new GD Resource.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @return boolean|\WP_Error
+ 	 */
+ 	public function load() {
+ 		if ( $this->image )
+ 			return true;
+ 
+ 		if ( ! is_file( $this->file ) && ! preg_match( '|^https?://|', $this->file ) )
+ 			return new WP_Error( 'error_loading_image', __('File doesn&#8217;t exist?'), $this->file );
+ 
+ 		// Set artificially high because GD uses uncompressed images in memory
+ 		@ini_set( 'memory_limit', apply_filters( 'image_memory_limit', WP_MAX_MEMORY_LIMIT ) );
+ 		$this->image = @imagecreatefromstring( file_get_contents( $this->file ) );
+ 
+ 		if ( ! is_resource( $this->image ) )
+ 			return new WP_Error( 'invalid_image', __('File is not an image.'), $this->file );
+ 
+ 		$size = @getimagesize( $this->file );
+ 		if ( ! $size )
+ 			return new WP_Error( 'invalid_image', __('Could not read image size.'), $this->file );
+ 
+ 		$this->update_size( $size[0], $size[1] );
+ 		$this->mime_type = $size['mime'];
+ 
+ 		return true;
+ 	}
+ 
+ 	/**
+ 	 * Sets or updates current image size.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access protected
+ 	 *
+ 	 * @param int $width
+ 	 * @param int $height
+ 	 */
+ 	protected function update_size( $width = false, $height = false ) {
+ 		if ( ! $width )
+ 			$width = imagesx( $this->image );
+ 
+ 		if ( ! $height )
+ 			$height = imagesy( $this->image );
+ 
+ 		return parent::update_size( $width, $height );
+ 	}
+ 
+ 	/**
+ 	 * Resizes current image.
+ 	 * Wraps _resize, since _resize returns a GD Resource.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param int $max_w
+ 	 * @param int $max_h
+ 	 * @param boolean $crop
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	public function resize( $max_w, $max_h, $crop = false ) {
+ 		if ( ( $this->size['width'] == $max_w ) && ( $this->size['height'] == $max_h ) )
+ 			return true;
+ 
+ 		$resized = $this->_resize( $max_w, $max_h, $crop );
+ 
+ 		if ( is_resource( $resized ) ) {
+ 			imagedestroy( $this->image );
+ 			$this->image = $resized;
+ 			return true;
+ 
+ 		} elseif ( is_wp_error( $resized ) )
+ 			return $resized;
+ 
+ 		return new WP_Error( 'image_resize_error', __('Image resize failed.'), $this->file );
+ 	}
+ 
+ 	protected function _resize( $max_w, $max_h, $crop = false ) {
+ 		$dims = image_resize_dimensions( $this->size['width'], $this->size['height'], $max_w, $max_h, $crop );
+ 		if ( ! $dims ) {
+ 			return new WP_Error( 'error_getting_dimensions', __('Could not calculate resized image dimensions'), $this->file );
+ 		}
+ 		list( $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h ) = $dims;
+ 
+ 		$resized = wp_imagecreatetruecolor( $dst_w, $dst_h );
+ 		imagecopyresampled( $resized, $this->image, $dst_x, $dst_y, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h );
+ 
+ 		if ( is_resource( $resized ) ) {
+ 			$this->update_size( $dst_w, $dst_h );
+ 			return $resized;
+ 		}
+ 
+ 		return new WP_Error( 'image_resize_error', __('Image resize failed.'), $this->file );
+ 	}
+ 
+ 	/**
+ 	 * Processes current image and saves to disk
+ 	 * multiple sizes from single source.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param array $sizes { {'width'=>int, 'height'=>int, 'crop'=>bool}, ... }
+ 	 * @return array
+ 	 */
+ 	public function multi_resize( $sizes ) {
+ 		$metadata = array();
+ 		$orig_size = $this->size;
+ 
+ 		foreach ( $sizes as $size => $size_data ) {
+ 			$image = $this->_resize( $size_data['width'], $size_data['height'], $size_data['crop'] );
+ 
+ 			if( ! is_wp_error( $image ) ) {
+ 				$resized = $this->_save( $image );
+ 
+ 				imagedestroy( $image );
+ 
+ 				if ( ! is_wp_error( $resized ) && $resized ) {
+ 					unset( $resized['path'] );
+ 					$metadata[$size] = $resized;
+ 				}
+ 			}
+ 
+ 			$this->size = $orig_size;
+ 		}
+ 
+ 		return $metadata;
+ 	}
+ 
+ 	/**
+ 	 * Crops Image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param string|int $src The source file or Attachment ID.
+ 	 * @param int $src_x The start x position to crop from.
+ 	 * @param int $src_y The start y position to crop from.
+ 	 * @param int $src_w The width to crop.
+ 	 * @param int $src_h The height to crop.
+ 	 * @param int $dst_w Optional. The destination width.
+ 	 * @param int $dst_h Optional. The destination height.
+ 	 * @param boolean $src_abs Optional. If the source crop points are absolute.
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	public function crop( $src_x, $src_y, $src_w, $src_h, $dst_w = null, $dst_h = null, $src_abs = false ) {
+ 		// If destination width/height isn't specified, use same as
+ 		// width/height from source.
+ 		if ( ! $dst_w )
+ 			$dst_w = $src_w;
+ 		if ( ! $dst_h )
+ 			$dst_h = $src_h;
+ 
+ 		$dst = wp_imagecreatetruecolor( $dst_w, $dst_h );
+ 
+ 		if ( $src_abs ) {
+ 			$src_w -= $src_x;
+ 			$src_h -= $src_y;
+ 		}
+ 
+ 		if ( function_exists( 'imageantialias' ) )
+ 			imageantialias( $dst, true );
+ 
+ 		imagecopyresampled( $dst, $this->image, 0, 0, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h );
+ 
+ 		if ( is_resource( $dst ) ) {
+ 			imagedestroy( $this->image );
+ 			$this->image = $dst;
+ 			$this->update_size();
+ 			return true;
+ 		}
+ 
+ 		return new WP_Error( 'image_crop_error', __('Image crop failed.'), $this->file );
+ 	}
+ 
+ 	/**
+ 	 * Rotates current image counter-clockwise by $angle.
+ 	 * Ported from image-edit.php
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param float $angle
+ 	 * @return boolean|WP_Error
+ 	 */
+ 	public function rotate( $angle ) {
+ 		if ( function_exists('imagerotate') ) {
+ 			$rotated = imagerotate( $this->image, $angle, 0 );
+ 
+ 			if ( is_resource( $rotated ) ) {
+ 				imagedestroy( $this->image );
+ 				$this->image = $rotated;
+ 				$this->update_size();
+ 				return true;
+ 			}
+ 		}
+ 		return new WP_Error( 'image_rotate_error', __('Image rotate failed.'), $this->file );
+ 	}
+ 
+ 	/**
+ 	 * Flips current image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param boolean $horz Horizontal Flip
+ 	 * @param boolean $vert Vertical Flip
+ 	 * @returns boolean|WP_Error
+ 	 */
+ 	public function flip( $horz, $vert ) {
+ 		$w = $this->size['width'];
+ 		$h = $this->size['height'];
+ 		$dst = wp_imagecreatetruecolor( $w, $h );
+ 
+ 		if ( is_resource( $dst ) ) {
+ 			$sx = $vert ? ($w - 1) : 0;
+ 			$sy = $horz ? ($h - 1) : 0;
+ 			$sw = $vert ? -$w : $w;
+ 			$sh = $horz ? -$h : $h;
+ 
+ 			if ( imagecopyresampled( $dst, $this->image, 0, 0, $sx, $sy, $w, $h, $sw, $sh ) ) {
+ 				imagedestroy( $this->image );
+ 				$this->image = $dst;
+ 				return true;
+ 			}
+ 		}
+ 		return new WP_Error( 'image_flip_error', __('Image flip failed.'), $this->file );
+ 	}
+ 
+ 	/**
+ 	 * Saves current in-memory image to file.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param string $destfilename
+ 	 * @param string $mime_type
+ 	 * @return array|WP_Error {'path'=>string, 'file'=>string, 'width'=>int, 'height'=>int, 'mime-type'=>string}
+ 	 */
+ 	public function save( $filename = null, $mime_type = null ) {
+ 		$saved = $this->_save( $this->image, $filename, $mime_type );
+ 
+ 		if ( ! is_wp_error( $saved ) ) {
+ 			$this->file = $saved['path'];
+ 			$this->mime_type = $saved['mime-type'];
+ 		}
+ 
+ 		return $saved;
+ 	}
+ 
+ 	protected function _save( $image, $filename = null, $mime_type = null ) {
+ 		list( $filename, $extension, $mime_type ) = $this->get_output_format( $filename, $mime_type );
+ 
+ 		if ( ! $filename )
+ 			$filename = $this->generate_filename( null, null, $extension );
+ 
+ 		if ( 'image/gif' == $mime_type ) {
+ 			if ( ! $this->make_image( $filename, 'imagegif', array( $image, $filename ) ) )
+ 				return new WP_Error( 'image_save_error', __('Image Editor Save Failed') );
+ 		}
+ 		elseif ( 'image/png' == $mime_type ) {
+ 			// convert from full colors to index colors, like original PNG.
+ 			if ( function_exists('imageistruecolor') && ! imageistruecolor( $image ) )
+ 				imagetruecolortopalette( $image, false, imagecolorstotal( $image ) );
+ 
+ 			if ( ! $this->make_image( $filename, 'imagepng', array( $image, $filename ) ) )
+ 				return new WP_Error( 'image_save_error', __('Image Editor Save Failed') );
+ 		}
+ 		elseif ( 'image/jpeg' == $mime_type ) {
+ 			if ( ! $this->make_image( $filename, 'imagejpeg', array( $image, $filename, apply_filters( 'jpeg_quality', $this->quality, 'image_resize' ) ) ) )
+ 				return new WP_Error( 'image_save_error', __('Image Editor Save Failed') );
+ 		}
+ 		else {
+ 			return new WP_Error( 'image_save_error', __('Image Editor Save Failed') );
+ 		}
+ 
+ 		// Set correct file permissions
+ 		$stat = stat( dirname( $filename ) );
+ 		$perms = $stat['mode'] & 0000666; //same permissions as parent folder, strip off the executable bits
+ 		@ chmod( $filename, $perms );
+ 
+ 		return array(
+ 			'path' => $filename,
+ 			'file' => wp_basename( apply_filters( 'image_make_intermediate_size', $filename ) ),
+ 			'width' => $this->size['width'],
+ 			'height' => $this->size['height'],
+ 			'mime-type'=> $mime_type,
+ 		);
+ 	}
+ 
+ 	/**
+ 	 * Returns stream of current image.
+ 	 *
+ 	 * @since 3.5.0
+ 	 * @access public
+ 	 *
+ 	 * @param string $mime_type
+ 	 */
+ 	public function stream( $mime_type = null ) {
+ 		list( $filename, $extension, $mime_type ) = $this->get_output_format( null, $mime_type );
+ 
+ 		switch ( $mime_type ) {
+ 			case 'image/png':
+ 				header( 'Content-Type: image/png' );
+ 				return imagepng( $this->image );
+ 			case 'image/gif':
+ 				header( 'Content-Type: image/gif' );
+ 				return imagegif( $this->image );
+ 			default:
+ 				header( 'Content-Type: image/jpeg' );
+ 				return imagejpeg( $this->image, null, $this->quality );
+ 		}
+ 	}
+ }
